package gui.views.inside;
#if($innerview_authorization == true)
import gui.buttons.AuthorizeButton;
#end
import gui.buttons.DefaultButton;
import gui.views.ScrollPanel;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import main.ElevatorSimulator;
import properties.ProgramSettings;
#if($innerview_emergencybutton == true)
import gui.buttons.EmergencyButton;
#end

public class ControlPanel extends ScrollPanel {
	

	private static final long serialVersionUID = 1048074068165896521L;
	
	private ArrayList<DefaultButton> lButtons;
	
	private int iElevatorIndex;
	
	#if($innerview_emergencybutton == true)
		
	private EmergencyButton emergencyButton;
	
	public EmergencyButton getEmergencyButton() {
		return emergencyButton;
	}
	
	#end
	
	
	#if($innerview_doorbutton == true)
	
	private JButton openButton;
	
	private JButton closeButton;
	
	/**
	 * @return the openButton
	 */
	public JButton getOpenButton() {
		return openButton;
	}

	/**
	 * @return the closeButton
	 */
	public JButton getCloseButton() {
		return closeButton;
	}
	#end
	
	/**
	 * @return the lButtons
	 */
	public ArrayList<DefaultButton> getButtons() {
		return lButtons;
	}
	
	
	public ControlPanel(int iElevatorIndex) {
		super();
		this.iElevatorIndex = iElevatorIndex;
		lButtons = new ArrayList<DefaultButton>($floors);
		
		init();
	}

	public void init() {
		int iwButton = 30;
		int ihButton = 15;
		// neue Scrollclasse, damit in durch die Tabs gescrollt werden kann.

		this.setLayout(new GridLayout(2 + ($floors / 6),
				6));
		this.setPreferredSize(new Dimension(350, (ihButton + 5)
				* ($floors / 4) + 40));
		
		//Button zum offen halten und schlieen der Tr
		#if($innerview_doorbutton == true)
		addOpenCloseButtons();
		#else
		this.add(new JLabel());
		#end
		
		//Notrufbutton
		#if($innerview_emergencybutton == true)
		addEmergencyButton();
		#else
		this.add(new JLabel());
		#end
		
		//Button fr Schutzbereiche 
		#if($innerview_authorization == true)
		this.add(new AuthorizeButton());
		#else
		this.add(new JLabel());
		#end

		
		// leere Labels adden, damit der erste Etagenbutton nicht direkt
		// neben dem Notrufbutton erscheint
		this.add(new JLabel());
		this.add(new JLabel());
		
		// Buttons erzeugen
		for (int i = 0; i < $floors; i++) {
			DefaultButton mjbButton = new DefaultButton(i, iElevatorIndex, true);
			mjbButton.setPreferredSize(new Dimension(iwButton, ihButton));

			lButtons.add(mjbButton);
			this.add(mjbButton);
		}
	}

	#if($innerview_doorbutton == true)
	/**
	 * f&uuml;gt die Buttons f&uuml;r T&uuml;r auf/zu in die GUI ein
	 */
	public void addOpenCloseButtons() {
		Icon close = new ImageIcon(getClass().getResource("/close.gif"));
		Icon open = new ImageIcon(getClass().getResource("/open.gif"));

		openButton = new JButton();
		openButton.setIcon(open);

		closeButton = new JButton();
		closeButton.setIcon(close);

		openButton.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				// Die Variable wird mit jedem Klick auf den Button invertiert.
				ElevatorSimulator.getInstance().getController(#if($elevators > 1) iElevatorIndex #end).getElevator()
						.setbKeepDoorsOpen(
								!ElevatorSimulator.getInstance().getController(#if($elevators > 1) iElevatorIndex #end)
										.getElevator().isbKeepDoorsOpen());
			}
		});
		closeButton.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				// Die Variable wird mit jedem Klick auf den Button invertiert.
				ElevatorSimulator.getInstance().getController(#if($elevators > 1) iElevatorIndex #end).getElevator()
						.setbCloseDoorsNow(
								!ElevatorSimulator.getInstance().getController(#if($elevators > 1) iElevatorIndex #end)
										.getElevator().isbCloseDoorsNow());
			}

		});

		this.add(openButton);
		this.add(closeButton);
	}
	#end

	
	#if($innerview_emergencybutton == true)
	/**
	 * Erzeugt Notruf-Button.
	 */
	private void addEmergencyButton() {
		emergencyButton = new EmergencyButton(-1, iElevatorIndex, true);
		emergencyButton.setPreferredSize(new Dimension(20, 20));
		this.add(emergencyButton);
	}
	#end	
}
